/*
 * Lcd_1602.c
 *
 * Created: 29.03.2020 23:21:14
 * Author: R0AEK
 * Ver - 1.05
 */ 

#include "Lcd_1602.h"

extern char verInfo[];			//   
extern char logo1[];			//   
extern char logo2[];			//-
extern char logo3[];			//-
extern uint8_t DisplayModule;	//   
unsigned char i2c_1602 = 0x4E;	//i2c     1602 (0x4E - PCF8574T, 0x7E - PCF8574AT)
unsigned char portlcd  = 0;		//       i2c   1602

void LCD_send_half_byte (unsigned char c)
{
	if ((DisplayModule == 1)||(DisplayModule == 2)||(DisplayModule == 3)||(DisplayModule == 4)) //  i2c
	{
		c <<= 4;
		e1;							//  
		I2C_SendByteByADDR(portlcd|c,i2c_1602);
		e0;							//  
	}
}

void LCD_send_byte (unsigned char c, unsigned char mode)
{
	unsigned char hc = 0;
	
	if ((DisplayModule == 1)||(DisplayModule == 2)||(DisplayModule == 3)||(DisplayModule == 4)) //  i2c
	{
		if (mode == 0)				//    
			rs0;
		else
			rs1;
	}
	
	hc = (c >> 4);				//   
	LCD_send_half_byte(hc);		//   LCD   
	LCD_send_half_byte(c);		//   LCD   
}

void LCD_send_char (unsigned char c)
{
	LCD_send_byte(c,1);
	_delay_ms(2);
}

void LCD_send_str (char str[])
{
	wchar_t n;
	for(n=0;str[n]!='\0';n++)
	LCD_send_char(str[n]);
}

void LCD_set_pos (unsigned char x, unsigned y)
{
	char adress;
	adress=(0x40*y+x)|0b10000000;
	LCD_send_byte(adress,0);
	_delay_ms(10);
}

void LCD_ini (void)
{
	/*  i2c*/
	if ((DisplayModule == 1)||(DisplayModule == 3))
	{
		ledOn();	// on
		setWrite();	//
	}
	
	if ((DisplayModule == 2)||(DisplayModule == 4)||(DisplayModule == 0))
	{
		ledOff();	// off
		setWrite();	//
	}
	
	for(int i=0;i<3;i++)
	{
		_delay_ms(50);
		LCD_send_half_byte(0x03);	//8   1 
	}
	_delay_ms(50);
	LCD_send_half_byte(0x02);		//4   1 
	_delay_ms(50);
	LCD_send_byte(0x28,0);			//4   2 
	_delay_ms(50);
	LCD_send_byte(0x06,0);			//    
	_delay_ms(50);
	
	LCD_send_byte(0x0C,0);			// LCD,  
	_delay_ms(50);
	LCD_send_byte(0x01,0);			// 
		
	//
	LCD_set_pos(0,0);				//    
	for (int i = 0; i < strlen_P(logo1); i++)
		LCD_send_char((char)pgm_read_byte(&logo1[i]));
	LCD_set_pos(0,1);				//    
	for (int i = 0; i < strlen_P(logo2); i++)
		LCD_send_char((char)pgm_read_byte(&logo2[i]));
	_delay_ms(1500);				//
	
	LCD_send_byte(0x01,0);			// 
	LCD_set_pos(0,0);				//    
	for (int i = 0; i < strlen_P(logo3); i++)
		LCD_send_char((char)pgm_read_byte(&logo3[i]));
	LCD_set_pos(0,1);				//    
	for (int i = 0; i < strlen_P(verInfo); i++)
		LCD_send_char((char)pgm_read_byte(&verInfo[i]));
	_delay_ms(1500);				//
	
	LCD_send_byte(0x01,0);			// 
	// 	
}