﻿/*
 * Main.h
 *
 * Created: 25.01.2021 11:32:26
 * Author: R0AEK
 * Ver - 1.05
 */ 

#ifndef MAIN_H_
#define MAIN_H_

#define F_CPU 16000000UL		//кварцевый резонатор для тактрирования МК на 16 МГц

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

#include "Lcd_1602.h"
#include "i2c.h"
#include "Usart.h"
#include "si5351a.h"
#include "SoftUART.h"
#include "OLED.h"

/*порт С, подключение GPS по SoftUART------*/
#define PINX_C				PINC
#define PORTX_C				PORTC
#define DDRX_C				DDRC
#define Soft_UART_RX_PIN	0
/*END порт С, подключение GPS по SoftUART--*/

/*перефирия--------------------------------*/
#define PINX_B				PINB
#define PORTX_B				PORTB
#define DDRX_B				DDRB
#define LED_Status			5
#define ABCD_D				0
#define PA_Pin				1

#define PINX_D				PIND
#define PORTX_D				PORTD
#define DDRX_D				DDRD
#define ABCD_A				5
#define ABCD_B				6
#define ABCD_C				7
/*END перефирия----------------------------*/

uint32_t dec_to_bin(uint32_t n);
void ABCD_Off(void);
void Strobe_L_LED(void);
void Transmit_WSPR (void);
void ReadXtallPLLAfrommEEPROM(void);
//---
void Receive_GPS_Data(char ch);
void Parsing_GPS_Message();

#endif /* MAIN_H_ */