﻿/*
 * Usart.h
 *
 * Created: 25.01.2021 11:32:26
 * Author: R0AEK
 * Ver - 1.05
 */

#ifndef USART_H_
#define USART_H_

#include "Main.h"

#define BAUD 9600				//скорость работы USART
#define MYUBRR F_CPU/16/BAUD-1	//расчет скорости передачи USART

//колецевые буферы приема и передачи для UART
#define BUFSIZERX 64			//размер буфера приема по UART
#define BUFSIZETX 64			//размер буфера передачи по UART
//UART Маски для обработки индексов кольцевых буферов:
#define BUFMASKRX (BUFSIZERX-1)
#define BUFMASKTX (BUFSIZETX-1)
//UART Буфер приема и его индексы:
char bufRX [BUFSIZERX];
unsigned char rxIn, rxOut;
//UART Буфер передачи и его индексы:
char bufTX [BUFSIZETX];
unsigned char txIn, txOut;
//END_колецевые буферы приема и передачи для UART

/*cтруктура ыремения для DS3231-------*/
typedef    struct
{
	uint8_t		Sec;
	uint8_t     Min;
	uint8_t     Hour;
} tpDateTime;
tpDateTime		DateTime;
/*END_cтруктура ыремения для DS3231---*/

void USART_Init(unsigned int ubrr);
void handlerTXUSART(void);
void handlerRXUSART(void);
void DefaultWriteTXOptions(void);
void ABCDDecode(void);
void ChangeTestActiveBand(void);
void WriteCorrXtall(void);
void SendByteToCircularBuffer(int idx);
void SendStringDataToUSART(char *str);
void RX_Data_Parsing(void);
void GPStoPC(void);
//void UART_Monitor(char *str);

//void Parsing_GPS_Message(void);


#endif /* USART_H_ */