/*
 * i2c.h
 *
 * Created: 25.01.2021 11:32:26
 * Author: R0AEK
 * Ver - 1.05
 */

#ifndef I2C_H
#define I2C_H

#include "Main.h"

#define I2C_START		0x08
#define I2C_START_RPT	0x10
#define I2C_SLA_W_ACK	0x18
#define I2C_SLA_R_ACK	0x40
#define I2C_DATA_ACK	0x28
#define I2C_WRITE		0xC0
#define I2C_READ		0xC1

unsigned char	rtcSec, rtcMin, rtcHour;									// ds3231

uint8_t			i2cStart();
void			i2cStop();
uint8_t			i2cByteSend(uint8_t data);
//uint8_t			i2cByteRead();

void			i2cInit();
uint8_t			i2cSendRegister(uint8_t reg, uint8_t data);					// si5351
uint8_t			i2cCurrentByteRead();										// ds3231
void			I2C_SendByteByADDR(unsigned char c,unsigned char addr);		// 1602 c i2c
unsigned char	RTC_ConvertFromBinDec(unsigned char c);						// ds3231
unsigned char	RTC_ConvertFromDec(unsigned char c);						// ds3231
void			DS3231_Write_Time(uint8_t rtcH, uint8_t rtcM, uint8_t rtcS);// ds3231
uint8_t			DS3231_Read_Time();											// ds3231

#endif //I2C_H
